loadClass("recv")
loadClass("send")

function core_main_loop( argv, handler )
{
	var sok = new java.net.Socket()
	sok.connect( new java.net.InetSocketAddress(argv[0], Number(argv[1])) )
	sok.setTcpNoDelay(true)

	var recv = create_receiver(sok.getInputStream())
	var send = create_sender(sok.getOutputStream())
	for(;;)
		try {
			var msg = recv()
			if( handler[msg.tag] )
				handler[msg.tag](msg, send)
		} catch(e) { // safety guard
			if( e.javaException instanceof java.io.IOException
			 || e.javaException instanceof java.util.NoSuchElementException )
				break
			print(e)
		}
	sok.close()
}
