loadClass("vector")

function create_receiver(is)
{
	var smcSep = new java.util.Scanner(is)
	smcSep.useDelimiter(";")

	// Parser
	function create_msgReader() {
		var spcSep = new java.util.Scanner(smcSep.next())
		return {
			next:  function()  { return spcSep.hasNext() ? String(spcSep.next()) : null },
			parse: function(a) { return [f(spcSep.next()) for each(f in a)] },
		}
	}
	var N=Number, S=String
	var Spd    = function(x) { return  N(x)/1000 }                 // per msec
	var Deg    = function(x) { return (N(x)+360)%360*Math.PI/180 } // rad 0..2pi
	var DegSpd = function(x) { return  N(x)*Math.PI/180/1000 }     // rad per msec

	// Read one message
	return function() {
		var mr = create_msgReader()
		var c  = mr.next()
		var m  = {tag: c}
		if( c == "T" ) {
			[[m.t, m.vc, m.x, m.y, m.d, m.spd], m.r, m.objs] = [mr.parse([ N,S,N,N,Deg,Spd ]), 0.5, []]
			m.p = vecR(m.x, m.y, m.r)
			for(var k;  k=mr.next(); m.objs.push(obj)) 
			{
				var obj = {tag: k}
				if( k != "m" )     [obj.x,obj.y,obj.r] =  mr.parse([ N,N,N ])
				else [[obj.x,obj.y,obj.d,obj.s],obj.r] = [mr.parse([ N,N,Deg,Spd ]), 0.4]
				obj.p = vecR(obj.x, obj.y, obj.r)
			}
		}
		else if( c == "I" ) [m.dx, m.dy, m.tl, m.msen, m.Msen, m.Mspd, m.Mtrn, m.Mhtrn] =
		                                 mr.parse([ N,N,N,N,N,Spd,DegSpd,DegSpd ])
		else if( c == "B" ) [m.t]      = mr.parse([ N ])
		else if( c == "C" ) [m.t]      = mr.parse([ N ])
		else if( c == "K" ) [m.t]      = mr.parse([ N ])
		else if( c == "E" ) [m.t, m.s] = mr.parse([ N,N ])
		return m
	}
}
